Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/src/Update_Prediction_Table_transition.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/src/Update_Prediction_Table_transition.cpp	(revision 121)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/src/Update_Prediction_Table_transition.cpp	(revision 122)
@@ -453,10 +466,4 @@
                       reg_UFPT_UPDATE [context] = ((depth==0)?_param->_size_ufpt_queue[context]:depth)-1;
                       log_printf(TRACE,Update_Prediction_Table,FUNCTION,"    * reg_UFPT_UPDATE (after ) : %d",reg_UFPT_UPDATE [context]);
-                      // Free a register that need update ?
-                      if (need_update(reg_UPDATE_FETCH_PREDICTION_TABLE [context][depth]._condition))
-                        {
-                          reg_UFPT_NB_NEED_UPDATE [context] --;
-                          log_printf(TRACE,Update_Prediction_Table,FUNCTION,"    * reg_UFPT_NB_NEED_UPDATE (after) : %d",reg_UFPT_NB_NEED_UPDATE [context]);
-                        }
                     }
                   else
@@ -464,5 +471,5 @@
                       log_printf(TRACE,Update_Prediction_Table,FUNCTION,"    * Update Prediction Table");
                       log_printf(TRACE,Update_Prediction_Table,FUNCTION,"      * reg_UPT_UPDATE (before) : %d",reg_UPT_UPDATE [context]);
-                      log_printf(TRACE,Update_Prediction_Table,FUNCTION,"      * reg_EVENT_STATE         : %s",toString(reg_EVENT_STATE [context]).c_str());
+                      log_printf(TRACE,Update_Prediction_Table,FUNCTION,"      * reg_UPT_EVENT_STATE     : %s",toString(upt_event_state).c_str());
  
                       // Change state
@@ -481,12 +488,11 @@
 #endif
 
-//                    bool have_event = ((reg_UPDATE_PREDICTION_TABLE [context][depth]._state == UPDATE_PREDICTION_STATE_KO) or
-//                                       (reg_UPDATE_PREDICTION_TABLE [context][depth]._state == UPDATE_PREDICTION_STATE_EVENT));
 #ifdef STATISTICS
                       Tbranch_condition_t condition = reg_UPDATE_PREDICTION_TABLE [context][depth]._condition;
 #endif
-                      bool ok     = (reg_UPDATE_PREDICTION_TABLE [context][depth]._state == UPDATE_PREDICTION_STATE_OK);
-                      bool ko     = (reg_UPDATE_PREDICTION_TABLE [context][depth]._state == UPDATE_PREDICTION_STATE_KO);
-
+                      bool ok = (reg_UPDATE_PREDICTION_TABLE [context][depth]._state == UPDATE_PREDICTION_STATE_OK);
+                      bool ko = (reg_UPDATE_PREDICTION_TABLE [context][depth]._state == UPDATE_PREDICTION_STATE_KO);
+
+                      // Test if branch is valid (prediction can be incorrect)
                       if (ok or ko)
                         {
@@ -508,18 +514,11 @@
                       if (ko)
                         {
-                          // Ko : wait end of all instruction
-//                           log_printf(TRACE,Update_Prediction_Table,FUNCTION,"    * UPT  [%d][%d].state <- UPDATE_PREDICTION_STATE_END_KO_WAIT_END (update)",context,depth);
-                          
-//                           reg_UPDATE_PREDICTION_TABLE [context][depth]._state = UPDATE_PREDICTION_STATE_END_KO_WAIT_END;
-
+                          // Ko
                           log_printf(TRACE,Update_Prediction_Table,FUNCTION,"    * UPT  [%d][%d].state <- UPDATE_PREDICTION_STATE_END_KO (update)",context,depth);
                           
+                          // Wait update of context_state
                           reg_UPDATE_PREDICTION_TABLE [context][depth]._state = UPDATE_PREDICTION_STATE_END_KO;
 
-                          reg_EVENT_VAL      [context] = true;
                           reg_EVENT_UPT_PTR  [context] = depth;
-//                        reg_EVENT_UPT_FULL [context] = 0;
-//                        reg_EVENT_UPT_FULL        [i] = (not reg_UPT_EMPTY [i] and (bottom == reg_UPT_TOP [i]));
-
 
 #ifdef STATISTICS
@@ -530,6 +529,5 @@
                       else
                         {
-//                           log_printf(TRACE,Update_Prediction_Table,FUNCTION,"    * UPT  [%d][%d].state <- UPDATE_PREDICTION_STATE_END_OK (update)",context,depth);
-//                           reg_UPDATE_PREDICTION_TABLE [context][depth]._state = UPDATE_PREDICTION_STATE_END_OK;
+                          // ok or event
 
                           log_printf(TRACE,Update_Prediction_Table,FUNCTION,"    * UPT  [%d][%d].state <- UPDATE_PREDICTION_STATE_END (update)",context,depth);
@@ -564,16 +562,24 @@
 //                            reg_UPT_UPDATE [context] = reg_UPT_BOTTOM[context];
 
-                              if (reg_EVENT_STATE [context] == EVENT_STATE_EVENT_FLUSH_UPT)
+                              switch (upt_event_state)
                                 {
-                                  reg_EVENT_STATE [context] = EVENT_STATE_OK;
+                                  // this case when don't need flush upt (miss decod and can continue)
+                                case UPT_EVENT_STATE_KO_MISS_FLUSH_UPT  : upt_event_state = UPT_EVENT_STATE_KO_COMMIT_UPDATE_CONTEXT; break;
+                                case UPT_EVENT_STATE_KO_EVENT_FLUSH_UPT : 
+                                  {
+                                    upt_event_state = UPT_EVENT_STATE_OK;
+                                    reg_UPT_TOP    [context] = reg_UPT_TOP_EVENT [context];
+                                    reg_UPT_UPDATE [context] = reg_UPT_TOP_EVENT [context];
+
+                                    break;
+                                  }
+                                default : break;
                                 }
-                              else
-                                {
-                                  reg_EVENT_STATE [context] = EVENT_STATE_UPDATE_CONTEXT;
-//                                   reg_EVENT_SOURCE[context] = EVENT_SOURCE_UPT;
-                                }
+                              
+                              reg_UPT_EVENT_STATE [context] = upt_event_state;
                             }
                           else
                             {
+                              // else, decrease update pointer
                               reg_UPT_UPDATE [context] = (((depth==0)?_param->_size_upt_queue[context]:depth)-1);
                             }
@@ -587,10 +593,10 @@
                         }
                       
-                      // Free the branch with no accurate ?
+                      // Test if freeing the branch with no accurate ?
                       if ((reg_UPDATE_PREDICTION_TABLE [context][depth]._is_accurate == false) and not ko)
                         reg_IS_ACCURATE [context] = true;
 
                       log_printf(TRACE,Update_Prediction_Table,FUNCTION,"      * reg_UPT_UPDATE (after ) : %d",reg_UPT_UPDATE[context]);
-                      log_printf(TRACE,Update_Prediction_Table,FUNCTION,"      * reg_EVENT_STATE         : %s",toString(reg_EVENT_STATE [context]).c_str());
+                      log_printf(TRACE,Update_Prediction_Table,FUNCTION,"      * reg_UPT_EVENT_STATE     : %s",toString(reg_UPT_EVENT_STATE [context]).c_str());
                     }
                 }
@@ -611,153 +617,167 @@
         //     * update status
         //   * Miss prediction :
-	for (uint32_t i=0; i<_param->_nb_inst_branch_complete; i++)
-	  if (PORT_READ(in_BRANCH_COMPLETE_VAL[i]) and internal_BRANCH_COMPLETE_ACK [i])
-	    {
-	      Tcontext_t context   = (_param->_have_port_context_id)?PORT_READ(in_BRANCH_COMPLETE_CONTEXT_ID [i]):0;
-	      Tdepth_t   depth     = (_param->_have_port_depth     )?PORT_READ(in_BRANCH_COMPLETE_DEPTH      [i]):0;
-              Tcontrol_t miss      = internal_BRANCH_COMPLETE_MISS_PREDICTION [i];
-              Tcontrol_t good_take = internal_BRANCH_COMPLETE_TAKE            [i];
-              Taddress_t good_addr = internal_BRANCH_COMPLETE_ADDRESS_DEST    [i];
-
-	      log_printf(TRACE,Update_Prediction_Table,FUNCTION,"  * BRANCH_COMPLETE[%d] - Accepted",i);
-	      log_printf(TRACE,Update_Prediction_Table,FUNCTION,"    * context             : %d",context);
-	      log_printf(TRACE,Update_Prediction_Table,FUNCTION,"    * depth               : %d",depth);
-	      log_printf(TRACE,Update_Prediction_Table,FUNCTION,"    * miss                : %d",miss);
-              log_printf(TRACE,Update_Prediction_Table,FUNCTION,"    * reg_EVENT_STATE     : %s",toString(reg_EVENT_STATE [context]).c_str());
-	      
-              if (miss)
-		{
-                  // Flush UPT
-                  uint32_t      top                 = reg_UPT_TOP [context];
-                  uint32_t      new_update          = ((top==0)?_param->_size_upt_queue[context]:top)-1; 
-                                                   
-                  Taddress_t    address_src         = reg_UPDATE_PREDICTION_TABLE [context][depth]._address_src;
-                  event_state_t event_state         = reg_EVENT_STATE [context];
-                  upt_state_t   event_top           = reg_UPDATE_PREDICTION_TABLE [context][top]._state;
-
-                  log_printf(TRACE,Update_Prediction_Table,FUNCTION,"    * event_top           : %s",toString(event_top).c_str());
-
-                  bool          previous_ufpt_event = ((event_state == EVENT_STATE_MISS_FLUSH_UFPT_AND_UPT ) or
-                                                       (event_state == EVENT_STATE_MISS_FLUSH_UFPT         ) or
-                                                       (event_state == EVENT_STATE_EVENT_FLUSH_UFPT_AND_UPT) or
-                                                       (event_state == EVENT_STATE_EVENT_FLUSH_UFPT        ));
-
-                  bool          previous_upt_event  = (false
-                                                       or  (event_state == EVENT_STATE_MISS_FLUSH_UFPT_AND_UPT )
-                                                       or  (event_state == EVENT_STATE_MISS_FLUSH_UPT          )
-                                                       or  (event_state == EVENT_STATE_EVENT_FLUSH_UFPT_AND_UPT)
-                                                       or  (event_state == EVENT_STATE_EVENT_FLUSH_UPT         )
-                                                       or  (event_top   == UPDATE_PREDICTION_STATE_END_KO      )
-                                                       or  (event_top   == UPDATE_PREDICTION_STATE_KO          )
-//                                                     or  (event_state == EVENT_STATE_WAIT_END_EVENT          )
-//                                                        or ((event_state == EVENT_STATE_UPDATE_CONTEXT          )
-//                                                            and (reg_EVENT_SOURCE [context] == EVENT_SOURCE_UPT))
-                                                       );
-//                bool          update_ras     = (new_update != depth);
-
-                  log_printf(TRACE,Update_Prediction_Table,FUNCTION,"    * top                 : %d",top);
-                  log_printf(TRACE,Update_Prediction_Table,FUNCTION,"    * new_update          : %d",new_update);
-//                log_printf(TRACE,Update_Prediction_Table,FUNCTION,"    * update_ras          : %d",update_ras);
-                  log_printf(TRACE,Update_Prediction_Table,FUNCTION,"    * previous_upt_event  : %d",previous_upt_event);
-                  log_printf(TRACE,Update_Prediction_Table,FUNCTION,"    * previous_ufpt_event : %d",previous_ufpt_event);
-                  log_printf(TRACE,Update_Prediction_Table,FUNCTION,"    * reg_UPT_UPDATE      : %d",reg_UPT_UPDATE [context]);
-                          
-                  // Have a miss !!!
-                  // Flush UPFT
-                  flush_UFPT [context] |= not previous_ufpt_event;
-                  
-                  if (reg_UPDATE_PREDICTION_TABLE [context][depth]._state == UPDATE_PREDICTION_STATE_WAIT_END)
-                    {
-                      for (uint32_t j=(depth+1)%_param->_size_upt_queue[context];
-                           j!=top; 
-                           j=(j+1)%_param->_size_upt_queue[context])
-                        {
-                          reg_UPDATE_PREDICTION_TABLE [context][j]._state = UPDATE_PREDICTION_STATE_EVENT;
-                          reg_UPDATE_PREDICTION_TABLE [context][j]._retire_ok = false;
-                        }
-                      
-                  
-//                    reg_UPT_BOTTOM    [context];
-                      reg_UPT_TOP       [context] = depth;
-//                    reg_UPT_TOP_EVENT [context] = top;
-                      
-                      if (not previous_upt_event)
-                        {
-                          reg_UPT_TOP_EVENT [context] = top;
-                          reg_UPT_UPDATE    [context] = new_update;
-                        }
-                      else
-                        {
-                          // Have event. Top index this slot
-                          reg_UPDATE_PREDICTION_TABLE [context][top]._retire_ok = false;
-
-                          switch (event_top)
-                            {
-                            case UPDATE_PREDICTION_STATE_END_KO : 
+        {
+          bool branch_complete_miss [_param->_nb_context];
+          for (uint32_t i=0; i<_param->_nb_context; ++i)
+            branch_complete_miss [i] = false;
+
+          for (uint32_t i=0; i<_param->_nb_inst_branch_complete; i++)
+            if (PORT_READ(in_BRANCH_COMPLETE_VAL[i]) and internal_BRANCH_COMPLETE_ACK [i])
+              {
+                // Read information
+                Tcontext_t context   = (_param->_have_port_context_id)?PORT_READ(in_BRANCH_COMPLETE_CONTEXT_ID [i]):0;
+                Tdepth_t   depth     = (_param->_have_port_depth     )?PORT_READ(in_BRANCH_COMPLETE_DEPTH      [i]):0;
+                Tcontrol_t miss      = internal_BRANCH_COMPLETE_MISS_PREDICTION [i];
+                Tcontrol_t good_take = internal_BRANCH_COMPLETE_TAKE            [i];
+                Taddress_t good_addr = internal_BRANCH_COMPLETE_ADDRESS_DEST    [i];
+                
+                upt_event_state_t upt_event_state  = reg_UPT_EVENT_STATE [context];
+                
+                log_printf(TRACE,Update_Prediction_Table,FUNCTION,"  * BRANCH_COMPLETE[%d] - Accepted",i);
+                log_printf(TRACE,Update_Prediction_Table,FUNCTION,"    * context             : %d",context);
+                log_printf(TRACE,Update_Prediction_Table,FUNCTION,"    * depth               : %d",depth);
+                log_printf(TRACE,Update_Prediction_Table,FUNCTION,"    * miss                : %d",miss);
+                log_printf(TRACE,Update_Prediction_Table,FUNCTION,"    * reg_UPT_EVENT_STATE : %s",toString(upt_event_state).c_str());
+                
+                // Test if the completed branch is a speculation miss
+                if (miss)
+                  {
+                    // special case : two branch complete on the same context.
+                    // when the re order keep the order, the branch complete j is most speculative that the branch comple i if i < j
+                    if (not branch_complete_miss [context])
+                      {
+                        branch_complete_miss [context] = true;
+                        // Flush UPT
+                        // get information
+                        uint32_t          top                 = reg_UPT_TOP [context];
+                        uint32_t          new_update          = ((top==0)?_param->_size_upt_queue[context]:top)-1; 
+                        
+                        Taddress_t        address_src         = reg_UPDATE_PREDICTION_TABLE [context][depth]._address_src;
+                        upt_state_t       event_top           = reg_UPDATE_PREDICTION_TABLE [context][top]._state;
+                        
+                        log_printf(TRACE,Update_Prediction_Table,FUNCTION,"    * upt_event_state     : %s",toString(upt_event_state).c_str());
+                        log_printf(TRACE,Update_Prediction_Table,FUNCTION,"    * event_top           : %s",toString(event_top).c_str());
+                        
+                        bool              previous_ufpt_event = (reg_UFPT_EVENT_STATE [i] == UFPT_EVENT_STATE_KO_FLUSH);
+                        
+                        
+                        bool              previous_upt_event  = (false
+                                                                 or (upt_event_state == UPT_EVENT_STATE_KO_MISS_WAIT_UFPT )
+                                                                 or (upt_event_state == UPT_EVENT_STATE_KO_MISS_FLUSH_UPT )
+                                                                 or (upt_event_state == UPT_EVENT_STATE_KO_EVENT_WAIT_UFPT)
+                                                                 or (upt_event_state == UPT_EVENT_STATE_KO_EVENT_FLUSH_UPT)
+                                                                 or (event_top       == UPDATE_PREDICTION_STATE_END_KO    )
+                                                                 or (event_top       == UPDATE_PREDICTION_STATE_KO        )
+                                                                 );
+                        
+                        log_printf(TRACE,Update_Prediction_Table,FUNCTION,"    * top                 : %d",top);
+                        log_printf(TRACE,Update_Prediction_Table,FUNCTION,"    * new_update          : %d",new_update);
+                        log_printf(TRACE,Update_Prediction_Table,FUNCTION,"    * previous_upt_event  : %d",previous_upt_event);
+                        log_printf(TRACE,Update_Prediction_Table,FUNCTION,"    * previous_ufpt_event : %d",previous_ufpt_event);
+                        log_printf(TRACE,Update_Prediction_Table,FUNCTION,"    * reg_UPT_UPDATE      : %d",reg_UPT_UPDATE [context]);
+                        
+                        // Have a miss !!!
+                        // Flush UPFT
+                        flush_UFPT [context] |= not previous_ufpt_event;
+                        
+                        // Test if the entry wait the branchment (else, they have a previous event)
+                        if (reg_UPDATE_PREDICTION_TABLE [context][depth]._state == UPDATE_PREDICTION_STATE_WAIT_END)
+                          {
+                            // All instruction between the instruction and the top is disable
+                            for (uint32_t j=(depth+1)%_param->_size_upt_queue[context];
+                                 j!=top; 
+                                 j=(j+1)%_param->_size_upt_queue[context])
                               {
-                                // Have already update predictor
-                                reg_UPDATE_PREDICTION_TABLE [context][top]._state = UPDATE_PREDICTION_STATE_END;
-                                reg_UPT_UPDATE              [context] = new_update;
-                                break;
+                                reg_UPDATE_PREDICTION_TABLE [context][j]._state     = UPDATE_PREDICTION_STATE_EVENT;
+                                reg_UPDATE_PREDICTION_TABLE [context][j]._retire_ok = false; // event
                               }
-                            case UPDATE_PREDICTION_STATE_KO :
+                            
+                            // New top
+                            reg_UPT_TOP       [context] = depth;
+                            
+                            if (not previous_upt_event)
                               {
-                                // Doesn't have update predictor
-                                reg_UPDATE_PREDICTION_TABLE [context][top]._state = UPDATE_PREDICTION_STATE_EVENT;
-                                break;
+                                reg_UPT_TOP_EVENT [context] = top;
+                                reg_UPT_UPDATE    [context] = new_update;
                               }
-                            default :
+                            else
                               {
-//                                 reg_UPDATE_PREDICTION_TABLE [context][top]._state = UPDATE_PREDICTION_STATE_EVENT;
+                                // Have event. Top index this slot
+                                reg_UPDATE_PREDICTION_TABLE [context][top]._retire_ok = false;
+                                
+                                switch (event_top)
+                                  {
+                                  case UPDATE_PREDICTION_STATE_END_KO : 
+                                    {
+                                      // Have already update predictor
+                                      reg_UPDATE_PREDICTION_TABLE [context][top]._state = UPDATE_PREDICTION_STATE_END;
+                                      reg_UPT_UPDATE              [context] = new_update;
+                                      break;
+                                    }
+                                  case UPDATE_PREDICTION_STATE_KO :
+                                    {
+                                      // Doesn't have update predictor
+                                      reg_UPDATE_PREDICTION_TABLE [context][top]._state = UPDATE_PREDICTION_STATE_EVENT;
+                                      break;
+                                    }
+                                  default :
+                                    {
+                                      //                                 reg_UPDATE_PREDICTION_TABLE [context][top]._state = UPDATE_PREDICTION_STATE_EVENT;
 //                                 break;
-
+                                      
 #ifdef DEBUG_TEST
-                                throw ERRORMORPHEO(FUNCTION,_("Branch complete : invalid upt state."));
-#endif
+                                      throw ERRORMORPHEO(FUNCTION,_("Branch complete : invalid upt state."));
+#endif
+                                    }
+                                  }
                               }
-                            }
-                        }
-                      
-                      if (reg_UPT_BOTTOM [context] == reg_UPT_TOP [context])
-                        reg_UPT_EMPTY [context] = true;
-                      
-                      log_printf(TRACE,Update_Prediction_Table,FUNCTION,"    * UPT  [%d][%d].state <- UPDATE_PREDICTION_STATE_KO (branch_complete, ifetch hit)",context,depth);
-                      reg_UPDATE_PREDICTION_TABLE [context][depth]._state = UPDATE_PREDICTION_STATE_KO;
-
-                      log_printf(TRACE,Update_Prediction_Table,FUNCTION,"    * reg_UFPT_NB_NEED_UPDATE [%d] : %d",context,reg_UFPT_NB_NEED_UPDATE [context]);
-                     
-                      if ( (reg_UFPT_NB_NEED_UPDATE [context] > 0) or
-                           (reg_UFPT_NB_UPDATE      [context] > 0))
-                        {
-                          log_printf(TRACE,Update_Prediction_Table,FUNCTION,"    * EVENT [%d] <- EVENT_STATE_MISS_FLUSH_UFPT_AND_UPT (branch_complete - miss)",context);
-                          reg_EVENT_STATE [context] = EVENT_STATE_MISS_FLUSH_UFPT_AND_UPT;
-                        }
-                      else
-                        {
-//                        if (not previous_update_ras)
-                          {
-                            // have ras prediction ?
-                            log_printf(TRACE,Update_Prediction_Table,FUNCTION,"    * EVENT [%d] <- EVENT_STATE_MISS_FLUSH_UPT (branch_complete - miss)",context);
                             
-                            reg_EVENT_STATE [context] = EVENT_STATE_MISS_FLUSH_UPT;
+                            if (reg_UPT_BOTTOM [context] == reg_UPT_TOP [context])
+                              reg_UPT_EMPTY [context] = true;
+                            
+                            log_printf(TRACE,Update_Prediction_Table,FUNCTION,"    * UPT  [%d][%d].state <- UPDATE_PREDICTION_STATE_KO (branch_complete, ifetch hit)",context,depth);
+                            reg_UPDATE_PREDICTION_TABLE [context][depth]._state = UPDATE_PREDICTION_STATE_KO;
+                            
+                            log_printf(TRACE,Update_Prediction_Table,FUNCTION,"    * reg_UFPT_NB_NEED_UPDATE [%d] : %d",context,reg_UFPT_NB_NEED_UPDATE [context]);
+                            
+//                       if ( (reg_UFPT_NB_NEED_UPDATE [context] > 0) or
+//                            (reg_UFPT_NB_UPDATE      [context] > 0))
+//                         {
+//                           log_printf(TRACE,Update_Prediction_Table,FUNCTION,"    * EVENT [%d] <- EVENT_STATE_MISS_FLUSH_UFPT_AND_UPT (branch_complete - miss)",context);
+//                           reg_EVENT_STATE [context] = EVENT_STATE_MISS_FLUSH_UFPT_AND_UPT;
+//                         }
+//                       else
+//                         {
+// //                        if (not previous_update_ras)
+//                           {
+//                             // have ras prediction ?
+//                             log_printf(TRACE,Update_Prediction_Table,FUNCTION,"    * EVENT [%d] <- EVENT_STATE_MISS_FLUSH_UPT (branch_complete - miss)",context);
+                            
+//                             reg_EVENT_STATE [context] = EVENT_STATE_MISS_FLUSH_UPT;
+                            
+//                           }
+//                         }
+
+                            reg_UPT_EVENT_STATE [context] = UPT_EVENT_STATE_KO_MISS_FLUSH_UPT;
+                            log_printf(TRACE,Update_Prediction_Table,FUNCTION,"    * UPT_EVENT_STATE [%d] <- %s (branch_complete, ifetch hit)",context,toString(reg_UPT_EVENT_STATE [context]).c_str());
+                            
+                            //                       reg_EVENT_SOURCE          [context] = EVENT_SOURCE_UPT;
+                            
+                            // else no update
+                            
+                            //                       reg_EVENT_IS_BRANCH       [context] = true;
+                            reg_EVENT_DEPTH           [context] = depth;
+                            reg_EVENT_ADDRESS_SRC     [context] = address_src; // delay_slot is compute in Context_State
+                            reg_EVENT_ADDRESS_DEST_VAL[context] = good_take;
+                            reg_EVENT_ADDRESS_DEST    [context] = good_addr;
+                            reg_EVENT_CAN_CONTINUE    [context] = false;
                             
                           }
-                        }
-//                       reg_EVENT_SOURCE          [context] = EVENT_SOURCE_UPT;
-                      
-                      // else no update
-                      
-                      reg_EVENT_IS_BRANCH       [context] = true;
-                      reg_EVENT_DEPTH           [context] = depth;
-                      reg_EVENT_ADDRESS_SRC     [context] = address_src; // delay_slot is compute in Context_State
-                      reg_EVENT_ADDRESS_DEST_VAL[context] = good_take;
-                      reg_EVENT_ADDRESS_DEST    [context] = good_addr;
-                      reg_EVENT_CAN_CONTINUE    [context] = false;
-
-                    }
-                  reg_UPDATE_PREDICTION_TABLE [context][depth]._miss_commit = true;
-                }
-	      else
-		{
+                        
+                        reg_UPDATE_PREDICTION_TABLE [context][depth]._miss_commit = true;
+                      }
+                  }
+                else
+                  {
                   // Hit case
 
@@ -767,25 +787,26 @@
 // #endif
 
-                  if (reg_UPDATE_PREDICTION_TABLE [context][depth]._state == UPDATE_PREDICTION_STATE_WAIT_END)
-                    {
-                      log_printf(TRACE,Update_Prediction_Table,FUNCTION,"    * UPT  [%d][%d].state <- UPDATE_PREDICTION_STATE_OK (branch_complete, ifetch hit)",context,depth);
-                      reg_UPDATE_PREDICTION_TABLE [context][depth]._state = UPDATE_PREDICTION_STATE_OK;
-                    }
-		}
-
-              log_printf(TRACE,Update_Prediction_Table,FUNCTION,"    * reg_EVENT_STATE     : %s",toString(reg_EVENT_STATE [context]).c_str());
-
-	      // In all case : update good_take
-	      reg_UPDATE_PREDICTION_TABLE [context][depth]._good_take    = good_take;
-
-              // Write address_dest if need read register
-              Tbranch_condition_t condition = reg_UPDATE_PREDICTION_TABLE [context][depth]._condition;
-              
-              if ((condition == BRANCH_CONDITION_READ_REGISTER_WITHOUT_WRITE_STACK) or
-                  (condition == BRANCH_CONDITION_READ_REGISTER_WITH_WRITE_STACK   ) or
-                  (condition == BRANCH_CONDITION_READ_STACK                       ) )
-                reg_UPDATE_PREDICTION_TABLE [context][depth]._address_dest = good_addr;
-            }
-
+                  // In same cycle, can have a previous branch_complete
+                    if (reg_UPDATE_PREDICTION_TABLE [context][depth]._state == UPDATE_PREDICTION_STATE_WAIT_END)
+                      {
+                        log_printf(TRACE,Update_Prediction_Table,FUNCTION,"    * UPT  [%d][%d].state <- UPDATE_PREDICTION_STATE_OK (branch_complete, ifetch hit)",context,depth);
+                        reg_UPDATE_PREDICTION_TABLE [context][depth]._state = UPDATE_PREDICTION_STATE_OK;
+                      }
+                  }
+                
+                log_printf(TRACE,Update_Prediction_Table,FUNCTION,"    * reg_UPT_EVENT_STATE : %s",toString(reg_UPT_EVENT_STATE [context]).c_str());
+                
+                // In all case : update good_take
+                reg_UPDATE_PREDICTION_TABLE [context][depth]._good_take    = good_take;
+                
+                // Write address_dest if need read register
+                Tbranch_condition_t condition = reg_UPDATE_PREDICTION_TABLE [context][depth]._condition;
+                
+                if ((condition == BRANCH_CONDITION_READ_REGISTER_WITHOUT_WRITE_STACK) or
+                    (condition == BRANCH_CONDITION_READ_REGISTER_WITH_WRITE_STACK   ) or
+                    (condition == BRANCH_CONDITION_READ_STACK                       ) )
+                  reg_UPDATE_PREDICTION_TABLE [context][depth]._address_dest = good_addr;
+              }
+        }
 
  	// ===================================================================
@@ -797,11 +818,15 @@
 	      log_printf(TRACE,Update_Prediction_Table,FUNCTION,"  * BRANCH_EVENT [%d] - Accepted",i);
 
-              // if different : an other branch is occured
-              if (reg_EVENT_STATE        [i] == EVENT_STATE_UPDATE_CONTEXT)
+              upt_event_state_t upt_event_state  = reg_UPT_EVENT_STATE [i];
+              
+              switch (upt_event_state)
                 {
-                  // Change state
-                  log_printf(TRACE,Update_Prediction_Table,FUNCTION,"    * EVENT [%d] <- EVENT_STATE_WAIT_END_EVENT (branch_event)",i);
-                  reg_EVENT_STATE [i] = EVENT_STATE_WAIT_END_EVENT;
+                case UPT_EVENT_STATE_KO_DECODE_UPDATE_CONTEXT : upt_event_state = UPT_EVENT_STATE_KO_DECODE_WAIT_END_EVENT; break;
+                case UPT_EVENT_STATE_KO_COMMIT_UPDATE_CONTEXT : upt_event_state = UPT_EVENT_STATE_KO_COMMIT_WAIT_END_EVENT; break;
+                default : break; // an other branch is occured
                 }
+
+              reg_UPT_EVENT_STATE [i] = upt_event_state;
+              log_printf(TRACE,Update_Prediction_Table,FUNCTION,"    * reg_UPT_EVENT_STATE : %s (branch_event)",toString(upt_event_state).c_str());
             }
 
